

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>d2o.analyze.correlation &mdash; d2o Python Library 1.0 documentation</title>
  

  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  

  

  
    <link rel="top" title="d2o Python Library 1.0 documentation" href="../../../index.html"/>
        <link rel="up" title="Module code" href="../../index.html"/> 

  
  <script src="../../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../../index.html" class="icon icon-home"> d2o Python Library
          

          
          </a>

          
            
            
              <div class="version">
                1.0
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="simple">
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../../../index.html">d2o Python Library</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          





<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../../../index.html">Docs</a> &raquo;</li>
      
          <li><a href="../../index.html">Module code</a> &raquo;</li>
      
    <li>d2o.analyze.correlation</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for d2o.analyze.correlation</h1><div class="highlight"><pre>
<span></span><span class="c1"># -*- encoding: utf-8 -*-</span>
<span class="c1">#</span>
<span class="c1"># Copyright (c) 2016 Chronos AS</span>
<span class="c1">#</span>
<span class="c1"># Authors: Fredrik Stormo, Stefan Remman</span>
<span class="c1"># Contact: kjetil.karlsen@chronosit.no</span>

<span class="kn">import</span> <span class="nn">pandas</span> <span class="kn">as</span> <span class="nn">pd</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span> <span class="c1">#Used for unittest</span>
<span class="kn">from</span> <span class="nn">os</span> <span class="kn">import</span> <span class="n">path</span> <span class="c1">#Used for unittest</span>

<span class="kn">from</span> <span class="nn">statsmodels.tsa.stattools</span> <span class="kn">import</span> <span class="n">acf</span><span class="p">,</span> <span class="n">pacf</span>
<span class="kn">import</span> <span class="nn">d2o.utils.logger</span> <span class="kn">as</span> <span class="nn">log</span>
<span class="kn">from</span> <span class="nn">d2o.utils.putils</span> <span class="kn">import</span> <span class="n">get_path_to_dataset</span>

<span class="c1"># TODO: Remove dependency on seaborn, replace with scipy.</span>
<span class="c1"># http://docs.scipy.org/doc/scipy/reference/generated/scipy.cluster.hierarchy.linkage.html</span>
<span class="kn">import</span> <span class="nn">seaborn</span> <span class="kn">as</span> <span class="nn">sns</span>

<span class="k">def</span> <span class="nf">__clamp</span><span class="p">(</span><span class="n">val</span><span class="p">,</span> <span class="n">_min</span><span class="p">,</span> <span class="n">_max</span><span class="p">):</span>
  <span class="k">return</span> <span class="nb">max</span><span class="p">(</span><span class="nb">min</span><span class="p">(</span><span class="n">_max</span><span class="p">,</span> <span class="n">val</span><span class="p">),</span> <span class="n">_min</span><span class="p">)</span>

<div class="viewcode-block" id="correlation_matrix"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.correlation.correlation_matrix">[docs]</a><span class="k">def</span> <span class="nf">correlation_matrix</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="n">method</span><span class="o">=</span><span class="s1">&#39;pearson&#39;</span><span class="p">,</span> <span class="n">sort</span><span class="o">=</span><span class="bp">True</span><span class="p">,</span> <span class="n">abs_values</span><span class="o">=</span><span class="bp">False</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
  <span class="c1"># TODO: Remove dependency on seaborn clustermap. Use scipy functions instead.</span>
  <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">  Creates and returns the correlation matrix of the dataframe.</span>

<span class="sd">  Parameters</span>
<span class="sd">  ----------</span>
<span class="sd">  df : pd.DataFrame</span>

<span class="sd">  method : str, default &#39;pearson&#39;</span>
<span class="sd">    vallid arguments: &#39;pearson&#39;, &#39;kendall&#39;, &#39;spearman&#39;.</span>

<span class="sd">  sort : bool, default True</span>
<span class="sd">    not implemented, does nothing. Indexes will be sorted regardless of this argument.</span>

<span class="sd">  plot : bool, default False</span>
<span class="sd">    Not implemented, function will not plot regardless of this argument.</span>

<span class="sd">  abs_values : bool, default False</span>
<span class="sd">    If True, returns matrix with absolute values.</span>

<span class="sd">  **kwargs</span>
<span class="sd">  --------</span>
<span class="sd">  sort_method : str, default &quot;average&quot;.</span>
<span class="sd">    Which method to use in sorting/clustering algorithm.</span>

<span class="sd">  Returns</span>
<span class="sd">  -------</span>
<span class="sd">  corrmat : pd.DataFrame</span>
<span class="sd">  &quot;&quot;&quot;</span>
  <span class="n">valid_methods</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;pearson&#39;</span><span class="p">,</span> <span class="s1">&#39;kendall&#39;</span><span class="p">,</span> <span class="s1">&#39;spearman&#39;</span><span class="p">]</span>
  <span class="k">if</span> <span class="p">(</span><span class="n">method</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">valid_methods</span><span class="p">):</span>
    <span class="k">raise</span> <span class="ne">Exception</span><span class="p">(</span><span class="s2">&quot;Invalid method &#39;</span><span class="si">%s</span><span class="s2">&#39;, valid methods are </span><span class="si">%s</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">method</span><span class="p">,</span> <span class="n">valid_methods</span><span class="p">))</span>
  <span class="n">corrmat</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">corr</span><span class="p">(</span><span class="n">method</span><span class="o">=</span><span class="n">method</span><span class="p">)</span>
  <span class="k">if</span> <span class="n">abs_values</span><span class="p">:</span>
    <span class="n">corrmat</span> <span class="o">=</span> <span class="n">corrmat</span><span class="o">.</span><span class="n">abs</span><span class="p">()</span>
  <span class="n">corrmat</span> <span class="o">=</span> <span class="n">corrmat</span><span class="o">.</span><span class="n">sort_index</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">ascending</span><span class="o">=</span><span class="bp">False</span><span class="p">)</span>
  <span class="n">corrmat</span> <span class="o">=</span> <span class="n">corrmat</span><span class="o">.</span><span class="n">sort_index</span><span class="p">(</span><span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">ascending</span><span class="o">=</span><span class="bp">False</span><span class="p">)</span>

  <span class="k">if</span> <span class="n">sort</span><span class="p">:</span>
    <span class="n">sort_method</span> <span class="o">=</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;sort_method&quot;</span><span class="p">,</span> <span class="s2">&quot;average&quot;</span><span class="p">)</span>
    <span class="n">cg</span> <span class="o">=</span> <span class="n">sns</span><span class="o">.</span><span class="n">clustermap</span><span class="p">(</span><span class="n">corrmat</span><span class="p">,</span> <span class="n">method</span><span class="o">=</span><span class="n">sort_method</span><span class="p">,</span> <span class="n">linewidths</span><span class="o">=.</span><span class="mi">5</span><span class="p">)</span>
    <span class="n">corrmat</span> <span class="o">=</span> <span class="n">corrmat</span><span class="p">[</span><span class="n">cg</span><span class="o">.</span><span class="n">dendrogram_col</span><span class="o">.</span><span class="n">reordered_ind</span><span class="p">]</span>
    <span class="n">corrmat</span> <span class="o">=</span> <span class="n">corrmat</span><span class="o">.</span><span class="n">reindex</span><span class="p">(</span><span class="n">corrmat</span><span class="o">.</span><span class="n">columns</span><span class="o">.</span><span class="n">values</span><span class="p">)</span>

  <span class="k">return</span> <span class="n">corrmat</span></div>

<div class="viewcode-block" id="autocorrelation"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.correlation.autocorrelation">[docs]</a><span class="k">def</span> <span class="nf">autocorrelation</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="n">confidence</span><span class="o">=</span><span class="mf">95.</span><span class="p">,</span> <span class="n">nlags</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span> <span class="n">keys</span><span class="o">=</span><span class="s2">&quot;ALL&quot;</span><span class="p">,</span> <span class="n">detrend</span><span class="o">=</span><span class="bp">False</span><span class="p">,</span> <span class="n">plot</span><span class="o">=</span><span class="bp">False</span><span class="p">,):</span>
  <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">  Calculates autocorrelation for each column in df.</span>

<span class="sd">  Parameters</span>
<span class="sd">  ----------</span>
<span class="sd">  df : pd.DataFrame</span>

<span class="sd">  confidence : float</span>
<span class="sd">    Default 95.</span>

<span class="sd">  nlags :</span>
<span class="sd">    Default None</span>

<span class="sd">  keys : string or list</span>
<span class="sd">    Default &quot;ALL&quot;</span>

<span class="sd">  detrend : bool</span>
<span class="sd">    Default False</span>

<span class="sd">  plot : bool</span>
<span class="sd">    Default False</span>

<span class="sd">  Returns</span>
<span class="sd">  -------</span>
<span class="sd">  aco : pd.DataFrame</span>
<span class="sd">    Columns contains aoutocorrelation of the columns in df with the</span>
<span class="sd">    confidence interval represented as two lines.</span>
<span class="sd">  &quot;&quot;&quot;</span>
  <span class="n">nlags</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">df</span><span class="p">)</span><span class="o">/</span><span class="mi">2</span><span class="p">)</span> <span class="k">if</span> <span class="p">(</span><span class="n">nlags</span> <span class="o">==</span> <span class="bp">None</span><span class="p">)</span> <span class="k">else</span> <span class="n">nlags</span>
  <span class="n">nlags</span> <span class="o">=</span> <span class="n">__clamp</span><span class="p">(</span><span class="n">nlags</span><span class="p">,</span><span class="mi">0</span><span class="p">,</span><span class="nb">len</span><span class="p">(</span><span class="n">df</span><span class="p">))</span><span class="o">-</span><span class="mi">1</span>
  <span class="n">alpha</span> <span class="o">=</span> <span class="p">(</span><span class="mf">100.0</span> <span class="o">-</span> <span class="n">confidence</span><span class="p">)</span><span class="o">/</span><span class="mf">100.0</span>

  <span class="k">try</span><span class="p">:</span>
    <span class="k">if</span> <span class="n">keys</span> <span class="o">==</span> <span class="s2">&quot;ALL&quot;</span><span class="p">:</span>
      <span class="n">keys</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">columns</span>
    <span class="k">elif</span> <span class="nb">type</span><span class="p">(</span><span class="n">keys</span><span class="p">)</span> <span class="o">==</span> <span class="nb">str</span><span class="p">:</span>
      <span class="n">keys</span> <span class="o">=</span> <span class="p">[</span><span class="n">keys</span><span class="p">]</span>
  <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
    <span class="n">log</span><span class="o">.</span><span class="n">err</span><span class="p">(</span><span class="n">ExceptionHandler</span><span class="p">(</span><span class="n">e</span><span class="p">))</span>

  <span class="n">resdict</span> <span class="o">=</span> <span class="p">{}</span>
  <span class="k">for</span> <span class="n">i</span><span class="p">,</span><span class="n">column</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">keys</span><span class="p">):</span>
    <span class="n">avals</span><span class="p">,</span> <span class="n">aconfint</span> <span class="o">=</span> <span class="n">acf</span><span class="p">(</span><span class="n">df</span><span class="p">[</span><span class="n">column</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">nlags</span><span class="o">=</span><span class="n">nlags</span><span class="p">,</span> <span class="n">alpha</span><span class="o">=</span><span class="n">alpha</span><span class="p">)</span>
    <span class="n">aconfint</span> <span class="o">=</span> <span class="n">aconfint</span> <span class="o">-</span> <span class="n">aconfint</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="mi">1</span><span class="p">)[:,</span><span class="bp">None</span><span class="p">]</span>

    <span class="n">resdict</span><span class="p">[</span><span class="n">column</span> <span class="o">+</span> <span class="s1">&#39;_ACF&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">avals</span>
    <span class="n">resdict</span><span class="p">[</span><span class="n">column</span> <span class="o">+</span> <span class="s1">&#39;_ACF_CONFINT_LOW&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">aconfint</span><span class="o">.</span><span class="n">T</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
    <span class="n">resdict</span><span class="p">[</span><span class="n">column</span> <span class="o">+</span> <span class="s1">&#39;_ACF_CONFINT_HIGH&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">aconfint</span><span class="o">.</span><span class="n">T</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>

  <span class="n">aco</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="o">.</span><span class="n">from_dict</span><span class="p">(</span><span class="n">resdict</span><span class="p">)</span>
  <span class="k">return</span> <span class="n">aco</span></div>

<div class="viewcode-block" id="partial_autocorr"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.correlation.partial_autocorr">[docs]</a><span class="k">def</span> <span class="nf">partial_autocorr</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="n">detrend</span><span class="o">=</span><span class="bp">False</span><span class="p">,</span> <span class="n">confidence</span><span class="o">=</span><span class="mf">95.</span><span class="p">,</span> <span class="n">nlags</span><span class="o">=</span><span class="bp">None</span><span class="p">,</span> <span class="n">plot</span><span class="o">=</span><span class="bp">False</span><span class="p">,</span> <span class="n">keys</span><span class="o">=</span><span class="s2">&quot;ALL&quot;</span><span class="p">):</span>
  <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">  Calculates partial autocorrelation for each column.</span>

<span class="sd">  Parameters</span>
<span class="sd">  ----------</span>
<span class="sd">  df : pd.DataFrame</span>

<span class="sd">  detrend : bool</span>
<span class="sd">    Default False</span>

<span class="sd">  confidence : float</span>
<span class="sd">    Default 95.</span>

<span class="sd">  nlags :</span>
<span class="sd">    Default None</span>

<span class="sd">  plot : bool</span>
<span class="sd">    Default False</span>

<span class="sd">  keys : string or list</span>
<span class="sd">    keys to iterate over.</span>

<span class="sd">  Returns</span>
<span class="sd">  -------</span>
<span class="sd">  paco : pd.DataFrame</span>
<span class="sd">    Dataframe with the partial autocorrelation per column, and the upper and</span>
<span class="sd">    lower bounds of the confidence interval as two lines.</span>
<span class="sd">  &quot;&quot;&quot;</span>
  <span class="n">nlags</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">df</span><span class="p">)</span><span class="o">/</span><span class="mi">2</span><span class="p">)</span> <span class="k">if</span> <span class="p">(</span><span class="n">nlags</span> <span class="o">==</span> <span class="bp">None</span><span class="p">)</span> <span class="k">else</span> <span class="n">nlags</span>
  <span class="n">nlags</span> <span class="o">=</span> <span class="n">__clamp</span><span class="p">(</span><span class="n">nlags</span><span class="p">,</span><span class="mi">0</span><span class="p">,</span><span class="nb">len</span><span class="p">(</span><span class="n">df</span><span class="p">))</span><span class="o">-</span><span class="mi">1</span>
  <span class="n">alpha</span> <span class="o">=</span> <span class="p">(</span><span class="mf">100.0</span> <span class="o">-</span> <span class="n">confidence</span><span class="p">)</span><span class="o">/</span><span class="mf">100.0</span>

  <span class="k">try</span><span class="p">:</span>
    <span class="k">if</span> <span class="n">keys</span> <span class="o">==</span> <span class="s2">&quot;ALL&quot;</span><span class="p">:</span>
      <span class="n">keys</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">columns</span>
    <span class="k">elif</span> <span class="nb">type</span><span class="p">(</span><span class="n">keys</span><span class="p">)</span> <span class="o">==</span> <span class="nb">str</span><span class="p">:</span>
      <span class="n">keys</span> <span class="o">=</span> <span class="p">[</span><span class="n">keys</span><span class="p">]</span>
  <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
    <span class="n">log</span><span class="o">.</span><span class="n">err</span><span class="p">(</span><span class="n">ExceptionHandler</span><span class="p">(</span><span class="n">e</span><span class="p">))</span>

  <span class="n">resdict</span> <span class="o">=</span> <span class="p">{}</span>
  <span class="k">for</span> <span class="n">i</span><span class="p">,</span><span class="n">column</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">keys</span><span class="p">):</span>
      <span class="n">pavals</span><span class="p">,</span> <span class="n">paconfint</span> <span class="o">=</span> <span class="n">pacf</span><span class="p">(</span><span class="n">df</span><span class="p">[</span><span class="n">column</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">nlags</span><span class="o">=</span><span class="n">nlags</span><span class="p">,</span> <span class="n">alpha</span><span class="o">=</span><span class="n">alpha</span><span class="p">)</span>
      <span class="n">paconfint</span> <span class="o">=</span> <span class="n">paconfint</span> <span class="o">-</span> <span class="n">paconfint</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="mi">1</span><span class="p">)[:,</span><span class="bp">None</span><span class="p">]</span>

      <span class="n">resdict</span><span class="p">[</span><span class="n">column</span> <span class="o">+</span> <span class="s1">&#39;_PACF&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">pavals</span>
      <span class="n">resdict</span><span class="p">[</span><span class="n">column</span> <span class="o">+</span> <span class="s1">&#39;_PACF_CONFINT_LOW&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">paconfint</span><span class="o">.</span><span class="n">T</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
      <span class="n">resdict</span><span class="p">[</span><span class="n">column</span> <span class="o">+</span> <span class="s1">&#39;_PACF_CONFINT_HIGH&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">paconfint</span><span class="o">.</span><span class="n">T</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>

  <span class="n">paco</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="o">.</span><span class="n">from_dict</span><span class="p">(</span><span class="n">resdict</span><span class="p">)</span>
  <span class="k">return</span> <span class="n">paco</span></div>


<span class="c1">#TESTING</span>
<span class="kn">import</span> <span class="nn">unittest</span>
<span class="c1"># TODO: Implement tests.</span>
<div class="viewcode-block" id="CorrealtionTests"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.correlation.CorrealtionTests">[docs]</a><span class="k">class</span> <span class="nc">CorrealtionTests</span><span class="p">(</span><span class="n">unittest</span><span class="o">.</span><span class="n">TestCase</span><span class="p">):</span>
<div class="viewcode-block" id="CorrealtionTests.setUp"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.correlation.CorrealtionTests.setUp">[docs]</a>  <span class="k">def</span> <span class="nf">setUp</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
    <span class="k">print</span> <span class="s2">&quot;setUP: correlation.py, need robust solution to file path&quot;</span>
    <span class="n">x</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">2</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">pi</span><span class="p">,</span> <span class="mi">50</span><span class="p">)</span>
    <span class="n">keys</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;x&quot;</span><span class="p">,</span> <span class="s2">&quot;np.sin(x)&quot;</span><span class="p">,</span> <span class="s2">&quot;np.cos(x)&quot;</span><span class="p">,</span> <span class="s2">&quot;np.tan(x)&quot;</span><span class="p">,</span> <span class="s2">&quot;np.abs(x)&quot;</span><span class="p">]</span>
    <span class="n">temp_dict</span> <span class="o">=</span> <span class="p">{}</span>
    <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">keys</span><span class="p">:</span>
      <span class="n">temp_dict</span><span class="p">[</span><span class="n">key</span><span class="p">]</span> <span class="o">=</span> <span class="nb">eval</span><span class="p">(</span><span class="n">key</span><span class="p">)</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">df</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="o">.</span><span class="n">from_dict</span><span class="p">(</span><span class="n">temp_dict</span><span class="p">)</span><span class="o">.</span><span class="n">set_index</span><span class="p">(</span><span class="s2">&quot;x&quot;</span><span class="p">)</span>

    <span class="n">file_path</span> <span class="o">=</span> <span class="n">get_path_to_datasett</span><span class="p">(</span><span class="s2">&quot;correlation_matrix_test_data.csv&quot;</span><span class="p">)</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">true_corr_mat</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_csv</span><span class="p">(</span><span class="n">file_path</span><span class="p">,</span> <span class="n">index_col</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span></div>

<div class="viewcode-block" id="CorrealtionTests.test_correlation_matrix"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.correlation.CorrealtionTests.test_correlation_matrix">[docs]</a>  <span class="k">def</span> <span class="nf">test_correlation_matrix</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
    <span class="k">print</span> <span class="s2">&quot;test_correlation_matrix: correlation.py&quot;</span>
    <span class="n">corr_mat</span> <span class="o">=</span> <span class="n">correlation_matrix</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="p">)</span>
    <span class="n">test_result</span> <span class="o">=</span> <span class="bp">True</span> <span class="c1"># If changed to False, this test fails.</span>
    <span class="n">epsilon</span> <span class="o">=</span> <span class="mf">1e-12</span> <span class="c1"># Error tolerance.</span>
    <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">corr_mat</span><span class="p">:</span>
      <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">xrange</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">corr_mat</span><span class="p">[</span><span class="n">key</span><span class="p">]</span><span class="o">.</span><span class="n">values</span><span class="p">)):</span>
        <span class="n">temp_var</span> <span class="o">=</span> <span class="nb">abs</span><span class="p">(</span><span class="n">corr_mat</span><span class="p">[</span><span class="n">key</span><span class="p">][</span><span class="n">i</span><span class="p">]</span><span class="o">-</span><span class="bp">self</span><span class="o">.</span><span class="n">true_corr_mat</span><span class="p">[</span><span class="n">key</span><span class="p">][</span><span class="n">i</span><span class="p">])</span>
        <span class="k">if</span> <span class="n">temp_var</span> <span class="o">&gt;</span> <span class="n">epsilon</span><span class="p">:</span>
          <span class="n">test_result</span> <span class="o">=</span> <span class="bp">False</span>
          <span class="k">break</span>
      <span class="k">if</span> <span class="n">test_result</span> <span class="o">==</span> <span class="bp">False</span><span class="p">:</span>
        <span class="k">break</span>

    <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="n">test_result</span><span class="p">,</span> <span class="n">msg</span><span class="o">=</span><span class="s2">&quot;No definitive error msg created&quot;</span><span class="p">)</span></div>

<div class="viewcode-block" id="CorrealtionTests.test_autocorrelation"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.correlation.CorrealtionTests.test_autocorrelation">[docs]</a>  <span class="k">def</span> <span class="nf">test_autocorrelation</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
    <span class="k">print</span> <span class="s2">&quot;test_autocorrealtion: correaltion.py&quot;</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="bp">False</span><span class="p">,</span> <span class="n">msg</span><span class="o">=</span><span class="s2">&quot;Test not implemented&quot;</span><span class="p">)</span></div>

<div class="viewcode-block" id="CorrealtionTests.test_partial_autocorr"><a class="viewcode-back" href="../../../d2o.analyze.html#d2o.analyze.correlation.CorrealtionTests.test_partial_autocorr">[docs]</a>  <span class="k">def</span> <span class="nf">test_partial_autocorr</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
    <span class="k">print</span> <span class="s2">&quot;test_partial_autocorr: correlation.py&quot;</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">assertTrue</span><span class="p">(</span><span class="bp">False</span><span class="p">,</span> <span class="n">msg</span><span class="o">=</span><span class="s2">&quot;Test not implemented&quot;</span><span class="p">)</span></div></div>


<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s2">&quot;__main__&quot;</span><span class="p">:</span>
  <span class="n">unittest</span><span class="o">.</span><span class="n">main</span><span class="p">()</span>

  <span class="c1"># TODO: Replace by unittest module.</span>
  <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">  print &quot;Executing test block...&quot;</span>
<span class="sd">  import numpy as np</span>
<span class="sd">  import matplotlib.pyplot as plt</span>
<span class="sd">  import time</span>

<span class="sd">  x = np.linspace(0, 10*np.pi, 1000)</span>

<span class="sd">  y1 = np.sin(x)</span>
<span class="sd">  y2 = x**2</span>

<span class="sd">  testFrame = pd.DataFrame.from_dict({&quot;var_1&quot; : y1, &quot;var_2&quot;: y2})</span>
<span class="sd">  # TODO: Test of autocorrelation()</span>
<span class="sd">  # TODO: Test of correlation_matrix()</span>

<span class="sd">  fig1 = plt.figure()</span>
<span class="sd">  ax = fig1.add_subplot(3, 1, 1)</span>
<span class="sd">  line = ax.plot(x, y1, label=&quot;sin(x)&quot;)</span>
<span class="sd">  ax.legend()</span>

<span class="sd">  #Test of partialAutoCorr()</span>
<span class="sd">  print &quot;Testing partialAutoCorr()&quot;</span>
<span class="sd">  PACStart = time.clock()</span>
<span class="sd">  PACFrame = partial_autocorr(testFrame)</span>
<span class="sd">  PACFinished = time.clock()</span>
<span class="sd">  PACTime = PACFinished - PACStart</span>
<span class="sd">  print &quot;Time used in partial_autocorr():&quot;, PACTime</span>

<span class="sd">  ax1 = fig1.add_subplot(3, 1, 2)</span>
<span class="sd">  line1 = ax1.plot(PACFrame[&quot;var_1_PACF&quot;], &#39;*&#39;,</span>
<span class="sd">                   PACFrame[&quot;var_1_PACF_CONFINT_LOW&quot;], &#39;r-&#39;,</span>
<span class="sd">                   PACFrame[&quot;var_1_PACF_CONFINT_HIGH&quot;], &#39;r-&#39;)</span>
<span class="sd">  #ax1.legend()</span>

<span class="sd">  #Test of autocorrelation</span>
<span class="sd">  print &quot;Testing autocorrelation()&quot;</span>
<span class="sd">  ACStart = time.clock()</span>
<span class="sd">  ACFrame = autocorrelation(testFrame)</span>
<span class="sd">  ACFinished = time.clock()</span>
<span class="sd">  ACTime = ACFinished - ACStart</span>
<span class="sd">  print &quot;Time used in autocorrelation():&quot;, ACTime</span>

<span class="sd">  ax2 = fig1.add_subplot(3, 1, 3)</span>
<span class="sd">  line2 = ax2.plot(ACFrame[&quot;var_1_ACF&quot;], &#39;*&#39;,</span>
<span class="sd">                   ACFrame[&quot;var_1_ACF_CONFINT_LOW&quot;], &#39;r-&#39;,</span>
<span class="sd">                   ACFrame[&quot;var_1_ACF_CONFINT_HIGH&quot;], &#39;r-&#39;)</span>
<span class="sd">  #ax2.legend()</span>

<span class="sd">  #Drawing the plots.</span>
<span class="sd">  print &quot;Drawing plot.&quot;</span>
<span class="sd">  fig1.canvas.draw()</span>
<span class="sd">  plt.show()</span>

<span class="sd">  #Output:</span>
<span class="sd">  &quot;&quot;&quot;</span>
  <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">  $ python correlation.py</span>
<span class="sd">  Executing test block...</span>
<span class="sd">  Testing partialAutoCorr()</span>
<span class="sd">  Time used in partialAutoCorr(): 24.03003</span>
<span class="sd">  Testing autocorrelation()</span>
<span class="sd">  Time used in autocorrelation(): 0.007206</span>
<span class="sd">  Drawing plot.</span>
<span class="sd">  &quot;&quot;&quot;</span>


</pre></div>

           </div>
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2016, Chronos AS.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../../',
            VERSION:'1.0',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

  

  
  
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>